
/* 


		!!!! NOTE TO THOSE READING THE SOURCE CODE !!!

		Hi & thanks for your interest in how this thing works.  Programming extensions is a bit ecclectic 
		and only moderately documented... I certainly benefited from others sharing their knowledge and I'm
		happy for you to do so as well with my code. Towards that end I have not used a JavaScript obfuscator.
		
		My one request is that you do not decrypt or post the stories. A lot of time was spent building
		this extension as the way of finding & reading the stories. Please do not cheat yourself &
		others by bypassing the extension.
		
		Thank you!
		
		Ethan
		ethan@ethanham.com


*/



// CHANGE LOG

// v  0.30
// 		Making code more friendly to IE:
//			Adding function that returns getDocument() for Firefox and "window.document" for other browsers
//          IE does all the file i/o stuff in the BHO and generates the needed info in JS dynamically.
//		Sped up adding paragraphs for long stories
//		Did full set of stories
//		Fixed bug that showed up on http://www.reuters.com/article/rbssConsumerGoodsAndRetailNews/idUSN1753132320081118
//			The page was being reloaded which wiped out our click event listener.  We now reestablish the listener when 
//			page is reloaded.
//
// v  0.31 11/23/2008
//		Found tumbas are forgotten when the page no longer qualifies for a story.
//		Deleted older change log items from this file
//
// v  0.32 11/23/2008
//		Fixing error in last release... was using an erroneous array index number	
//
// v  1.0  11/25/2008
//		No changes from 0.32
// v  1.01 11/27/2008
//		Reduced the frequency of tumba occurances
// v  1.02 11/28/2008
//      Two authors' names names were switched.  Fixed. Changed the names of some variables.
// v  1.03 11/30/2008
//  	Added copyright info for authors. Stop linking stories to test page. Slightly increased frequency of tumbas
// v  1.04 12/1/2008
//		Adjusted tumba frequency (increased slightly). Made first story found more likely & had that likliness stick.
// v  1.05 12/7/2008
//		Adjusted frequency.
// v  1.06 12/8/2008
//		Improved range of stories uncovered
// v  1.07 12/16/2008
//		Added alerting users to updates when they visit tumbarumba.org
// v  1.08 1/3/2009
//		Corrected the version of M@tch Girl that is used.
// v  1.09 1/19/2009
//		Story now automatically revealed only when browsing to it from TOC
// v  1.10 	
//		Updated to indicate that the add-on is compatible with 3.1b2
//		Isolated the functions & variables in the add-on to their own namespace
// v  1.11
//		No longer use eval to process data received from Flickr.com for security reasons
// v  1.12
//		The URL info that is included when users "submit a submission or bug report" (from the Tumbarumba menu) is
//		now escaped.
// v  1.13
//		Indicating that Tumbarumba is compatible with Firefox version 3.1b4
// v  1.14
//		Indicating that Tumbarumba is compatible with Firefox version 3.6a1pre
// v  1.15
//		Indicating that Tumbarumba is compatible with Firefox version 3.7a2pre
// v  1.16
//		Made getting the extension's directory compatible with FF 4.0 (using AddonManager instead of getService)
//		And added <em:unpack> to install.rdf



// CLASS DECLARATIONS ---------------



// This little bit of namespace hoodoo is to make sure our variables & functions
// are not colliding with others in the global namespace
if(!org) var org={};
if(!org.tumbarumba) org.tumbarumba={};

org.tumbarumba.myPackage = function(){


if(!checkIsFirefox())
{
	alert("change name of decrypt function");
	alert("change story macro so that break lines & href code use single quotes");
	alert("IE needs makeFlickrXMLHttpRequest");
	alert("IE needs end punctuation on fade-ins");
}

function FlickrInfo(imageURL, tag, photoLink)
{
	this.imageURL = imageURL;
	this.tag = tag;
	this.photoLink = photoLink;
}


// StoryInfo class... 
function StoryInfo(author, title, keywords, story)
{
	this.author = author;
	this.title = title;
	this.keywords = keywords;
	this.story = story;
}

// GLOBALS ------------------------
// Kinda like a singleton
var tumbarumbaGlobals = {
	addOnVersion		: 1.16,
	uniquifier			: 0,
	// extension 			: "",
	path 				: "",
	
	preferences 		: "",

	paragraphs			: new Array(),
	numParagraphs		: 0, 			// it seems that the array is being dynamically changed
										// I guess it is more of a pointer than a static array
	flickrArray			: new Array(),
	
	bTotalStoryShowing	: false,
	iCurr				: 0,
	currStoryText		: "",
	storyInfoArray		: new Array(),
	workingKeywords		: "",
	
	iNumIntrusions		: 0,
	iCurrVisible		: 0,
	tumbarumbaClick		: new Array(),
	
	disabledPages		: new Array(),
	
	foundTumbas			: new Array(),
	
	tumbaFreq			: 6,
	
	iMaxIntrusion		: 6,
	iMinIntrusion		: 1,

	intrusion			: "",
	
	// optional setting
	bRememberTumbas		: true, 	// The last found instance of each story will be fully visible when browsing to the page
									//		(rather than requiring the user to click through)
	bGiveFinger			: true,		// do insertions have a finger cursor on roll-over?
	
	bMatch				: false,  	
	bLog				: false,	// log debugging info
	bTimestampLog		: false,
	bFFVerEarlierThan4	: false

}

// -------------------------------------
 
if(checkIsFirefox())
{ 
	var appInfo = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo);
	var versionChecker = Components.classes["@mozilla.org/xpcom/version-comparator;1"].getService(Components.interfaces.nsIVersionComparator);

	if(versionChecker.compare(appInfo.version, "4.0") >= 0) 
	{
		AddonManager.getAddonByID("ethan@com.ethanham.tumbarumba", function(aAddon) {
			var file = aAddon.getResourceURI("").
			QueryInterface(Components.interfaces.nsIFileURL).file;
			
			tumbarumbaGlobals.path = file.path;
			
			startup();
			loadFoundTumbaList();

			
		});
	}
	else
	{
		tumbarumbaGlobals.path = Components.classes["@mozilla.org/extensions/manager;1"]
			.getService(Components.interfaces.nsIExtensionManager)
			.getInstallLocation("ethan@com.ethanham.tumbarumba")
			.getItemLocation("ethan@com.ethanham.tumbarumba").path;
		
		tumbarumbaGlobals.bFFVerEarlierThan4 = true;

	}

}

var tumbarumbaAgent = {

	onLoadStart : function()
	{	
	
		LOG_EVENT("********************************************");
		LOG_EVENT("page load:" + getDocument().URL);

        if(getDocument().body == null)
        {
			LOG_EVENT("null body");
            return;
        }

        if(tr_hasAttribute(getDocument().body, "tumbarumbaEmbedded"))
		{
			// "Reuters" fix... resetting up event listener
			var thingy = getDocument().getElementById("tumbarumba_block"); 

			if(thingy)
			{
				if(checkIsFirefox())		
					thingy.addEventListener("click", tumbarumbaGlobals.tumbarumbaClick, true);
				else
					thingy.attachEvent('onclick', tumbarumbaGlobals.tumbarumbaClick, true);
			}
			
			
			LOG_EVENT("tumba already embedded");
            return;
		}
	

		if(getDocument().body.getAttribute("id") == "tumbarumbaHome")
		{ 	
			onTumbarumbaHome();
			return;
		}
	
		getDocument().body.setAttribute("tumbarumbaEmbedded", "1");
	
		
		if(!checkIsEnabled())
		{
			LOG_EVENT("add-on not enabled");
			return;
		}
			
		if(checkIsFirefox()
		        && tumbarumbaGlobals.preferences.prefHasUserValue("extensions.tumbarumba.reloadDisabledList")
			 	&& tumbarumbaGlobals.preferences.getBoolPref("extensions.tumbarumba.reloadDisabledList"))
		{	
			LOG_EVENT("load disabled list");
	
			var aArray = new Array();
			loadArray(aArray, "disabled_pages.txt", false);
			
			tumbarumbaGlobals.disabledPages = new Array();
			for(i=0; i<aArray.length; i++)
				tumbarumbaGlobals.disabledPages[aArray[i]] = 1;	
				
			Components.classes['@mozilla.org/preferences-service;1'].
				getService(Components.interfaces.nsIPrefBranch).setBoolPref('extensions.tumbarumba.reloadDisabledList', 0);				
		}
		else if (!checkIsFirefox())
		{
		    alert("need to port disabled list");
		}
		
		var bTumbaTest = getDocument().body.getAttribute("id") == "tumbarumbaTest";
		
		// Check for disabled page
		var kwReg = new RegExp("(http://)?(www\.)?([^?]*)");
		var ar = kwReg.exec(getDocument().URL.toLowerCase());
		var currURL = ar[3];
		if(currURL[currURL.length-1] == "/")
			currURL = currURL.substr(0, currURL.length-1);
		if(!bTumbaTest && typeof(tumbarumbaGlobals.disabledPages[currURL]) != 'undefined')
		{
			LOG_EVENT(currURL + " is disabled");
			return;
		}

		// ----------------------------------------------
		// determine if we might embed this page 
	

		// don't embed in secure pages
		if(getDocument().URL.toLowerCase().substring(0,5) == "https")
		{
			LOG_EVENT("https page");
			return;
		}
		var totalVal = checkInsertTumbarumba(getDocument());

		if(!totalVal && !bTumbaTest) // don't insert
		{
			LOG_EVENT("not inserting tumba");
			
			for(var i = 0; i < tumbarumbaGlobals.foundTumbas.length; i++)
			{	
			
				if(tumbarumbaGlobals.foundTumbas[i] == getDocument().URL)
				{
					tumbarumbaGlobals.foundTumbas[i] = "";	
					tumbarumbaGlobals.preferences.setCharPref("extensions.tumbarumba."+i, "");
					
					break;
				}
			}
			
			return;
		}

		// check & see if this is the page that's on the TOC for this story,
		// if so, go ahead and show the story
		LOG_EVENT("inserting tumba");

		setupClickFunction();
		
		if(checkIsFirefox() && tumbarumbaGlobals.bRememberTumbas && !bTumbaTest)
		{		
			var kwReg = new RegExp("turbulence.org/works/tumbarumba");
			
			if(tumbarumbaGlobals.foundTumbas[tumbarumbaGlobals.iCurr] != "" 
				&& tumbarumbaGlobals.foundTumbas[tumbarumbaGlobals.iCurr] == getDocument().URL
				&& kwReg.test(getDocument().referrer.toLowerCase()))
			{
				LOG_EVENT("story " + tumbarumbaGlobals.iCurr + " was already found on this page");
				
				// do story replace					
				tumbarumbaGlobals.currStoryText = tumbarumbaGlobals.storyInfoArray[tumbarumbaGlobals.iCurr].story;
				tumbarumbaGlobals.workingKeywords = tumbarumbaGlobals.storyInfoArray[tumbarumbaGlobals.iCurr].keywords; 
				tumbarumbaGlobals.intrusion = GetRandomKeyword(getDocument().title );
				
				getPhotos();
				
				LOG_EVENT("displaying entire story");
				doTotalStoryReplace();
		
				return;

			}
		
		}
		else if(!checkIsFirefox())
		{
		    alert("need to port remembering tumbas");
		}		

		tumbarumbaGlobals.workingKeywords = tumbarumbaGlobals.storyInfoArray[tumbarumbaGlobals.iCurr].keywords; 
		tumbarumbaGlobals.currStoryText = tumbarumbaGlobals.storyInfoArray[tumbarumbaGlobals.iCurr].story;		
		tumbarumbaGlobals.intrusion = checkForWordMatch(totalVal);				

		if(tumbarumbaGlobals.intrusion == "")
		{
			LOG_EVENT("no intrusion found");
			trRemoveTag("tumbarumba0");
		}
		else
		{
			// switch the first intrusion so it displays & the original text doesn't		
			var element = getDocument().getElementById("tumbarumba0");	
			if(element)
				element.style.display = tumbarumbaFadingUtils.getDisplayTextType();
			element = getDocument().getElementById("tumbarumba_replace0");	
			if(element)
				element.style.display = "none";		
			
			FixReplacementLink(); 
			getPhotos();
	
			LOG_EVENT("intrusion found: " +  tumbarumbaGlobals.intrusion);				
//setTimeout ( timerFunctionTumba, 7000 );
		
// outputText(getDocument().body.innerHTML, tumbarumbaGlobals.extension.path + "/bug1.TXT");
		}	
	}

}
/*
function timerFunctionTumba()
{
	outputText(getDocument().body.innerHTML, tumbarumbaGlobals.extension.path + "/bug2.TXT");
}
*/



function checkInsertTumbarumba(doc)
{ 
	var totalVal = 0;
	tumbarumbaGlobals.bTotalStoryShowing = false;
	
	tumbarumbaFadingUtils.resetFades();
	
	tumbarumbaGlobals.paragraphs = doc.getElementsByTagName("p");
	tumbarumbaGlobals.numParagraphs = tumbarumbaGlobals.paragraphs.length;
	
	var bTumbaTest = getDocument().body.getAttribute("id") == "tumbarumbaTest";
	if(bTumbaTest)
		return 1;

	if(tumbarumbaGlobals.paragraphs.length == 0)
		return 0;

	var aString = doc.title + doc.URL; 
	for (var i = 0; i < aString.length && i < 15; i++) 
	{
		totalVal += aString.charCodeAt(i); // get numeric value
	}

	if(tumbarumbaGlobals.paragraphs.length > 3)
	{
		aString = tumbarumbaGlobals.paragraphs[3].innerHTML; 

		for (var i = 0; i < aString.length && i < 15; i++) 
		{
			totalVal += aString.charCodeAt(i); // get numeric value
		}
	}
	else
		return 0;	// don't really have enough content to imbed into		

	
	totalVal -= tumbarumbaGlobals.uniquifier;	
	if(totalVal < 0)
		totalVal *= -1;	


	tumbarumbaGlobals.iCurr = totalVal % (tumbarumbaGlobals.storyInfoArray.length);	

	
	
	aString = tumbarumbaGlobals.paragraphs[2].innerHTML; 

	for (var i = 0; i < aString.length && i < 15; i++) 
	{
		totalVal += aString.charCodeAt(i); // get numeric value
	}	
	
	LOG_EVENT("total val: " +  totalVal);	
	
	if(bTumbaTest)
		tumbarumbaGlobals.iCurr = 1;
	
	var freq = tumbarumbaGlobals.tumbaFreq;

	if(!checkTumbarumbaFound() || (getTumbarumbaFoundVal() != -1 && tumbarumbaGlobals.foundTumbas[getTumbarumbaFoundVal()] == getDocument().URL))
		freq = 3;
			

	if(tumbarumbaGlobals.bMatch || (totalVal > 0 && totalVal % freq == 0))
		return totalVal;
	else
		return 0;
	
}


function onTumbarumbaHome()
{
	var version = getDocument().getElementById("version");

	if(version == null || version.innerHTML > tumbarumbaGlobals.addOnVersion)
	{
		// new version is available!
		getDocument().body.setAttribute("tumbarumbaEmbedded", "1");
	
	}
	else
	{
		getDocument().body.setAttribute("tumbarumbaEmbeddedUpToDate", "1");

	}

	for(var i = 0; i < tumbarumbaGlobals.foundTumbas.length; i++)
	{		
		if(tumbarumbaGlobals.foundTumbas[i] != "")
		{
			var element = getDocument().getElementById(i+"Tumba");
			if(element)
			{
				element.innerHTML = "<a href='" + tumbarumbaGlobals.foundTumbas[i] + "'>" + element.innerHTML + "</a>";
				element.parentNode.setAttribute("class","style3");					
			}
		}
	}
}



function setupClickFunction()
{
	tumbarumbaGlobals.tumbarumbaClick = function()
										  {
											  if(tumbarumbaGlobals.iNumIntrusions == tumbarumbaGlobals.iCurrVisible)
											  {
												  if(!tumbarumbaFadingUtils.bStartedFinalFade)
												  {
													  tumbarumbaFadingUtils.bStartedFinalFade = true;
													  tumbarumbaFadingUtils.currFadeOutObjIDNum = -1;
													  tumbarumbaFadingUtils.currFadeOutOpacity = 100;
													  tumbarumbaFadingUtils.fadeOut();
												  }
											  }
											  else
											  { 
												  tumbarumbaGlobals.iCurrVisible++;
												  tumbarumbaFadingUtils.currfadeInObjIDNum++;
												  tumbarumbaFadingUtils.currfadeInOpacity = 0;
												  tumbarumbaFadingUtils.fadeIn();
											  }
										  };
	
}


if(checkIsFirefox())
{
  	window.addEventListener("DOMContentLoaded", tumbarumbaAgent.onLoadStart, true);
}
else
{
//    tumbarumbaAgent.onLoadStart();
}
 

function trRemoveTag(tagname)
{
	var element = getDocument().getElementById(tagname);	
	if(element)
		element.parentNode.removeChild(element);	
}


function GetRandomKeyword(aWord)
{	
	var randomizer = 0;
	for (var i = 0; i < aWord.length; i++) 
	{
		randomizer += aWord.charCodeAt(i); // get numeric value
	}
	
	randomizer *= tumbarumbaGlobals.uniquifier;
	
	var selectArray = tumbarumbaGlobals.workingKeywords.split("|");
	
//	alert(randomizer + ":" + selectArray[randomizer % selectArray.length]);
	if(selectArray.length == 0)
		return "";

	return selectArray[randomizer % selectArray.length];
}


var tagTest = new RegExp("option|script\s*>","i");

function checkForWordMatch(randomizer)
{
	// REMEMBER!!!!  DOUBLE \\ WHEN USING REG EXP IN STRINGS!!!
	var kwReg = new RegExp("([^\.\?\!]*\"?\\b)("+tumbarumbaGlobals.workingKeywords+")(\\b[^\.\?\!]*\"?)", "i");

	for(var para, count = 0; para = tumbarumbaGlobals.paragraphs[count]; ++count)
	{
		var aString = stripHTML(para.innerHTML);
	
		var ar = kwReg.exec(aString);	

		if(ar && ar[1].length && ar[3].length) // we're going to insert! (having checked that our key word isn't at beginning or end of sentence).
		{
			// skip this intrusion if the paragraph contains <option> tag
			// because that is text that is in the midst of a drop list
			// also skip if contains a <script> tag
		
			if(tagTest.test(para.innerHTML))
				continue;	
			
			var kwReg2 = new RegExp("([^\.\?\!\"]*\\b)("+ar[2]+")(\\b[^\.\?\!\"]*)(.*)", "i");
			ar2 = kwReg2.exec(tumbarumbaGlobals.currStoryText);

			if(!ar2)
				continue; // shouldn't happen
						
			var insertStringLen;

			if(ar[1].length < 15 || ar2[3].length < 15)
				continue; 		// not enough words to make it a good insertion		

			kwReg2 =  new RegExp(encodeRE(ar[2]+ar[3]), "i");
			
			if(!kwReg2.test(para.innerHTML))
			{
				// probably some HTML tags messing us up
				// para.innerHTML = stripHTML(para.innerHTML);
				continue; 
			}
		
			// remove any trailing punctuation (can be caused by the text being cut off at a ")
			ar2[3] = ar2[3].replace(/\W+$/, "");				
							
			//add a quote if the text we're replacing has an odd number of quotes		
			var numQuotes = ar[3].split("\"").length;
			if(1 != numQuotes % 2) // modulus will be 1 if even number of quotes
				ar2[3] += "\"";

			var replaceString = "<span id=\"tumbarumba_block\">"
								+"<span id=\"tumbarumba_replace0" // this is for changing text
								+"\" style=\"display:"+tumbarumbaFadingUtils.getDisplayTextType()+";"
								+tumbarumbaFadingUtils.writeBrowserOpaque()+"\">"  
								+ar[2]+ar[3]
								+"</span><span id=\"tumbarumba0"
								+"\" style=\"display:none;\">" 
								+ ar[2] + ar2[3] 
								+ "</span>";						

			tumbarumbaGlobals.iNumIntrusions = 0;
			tumbarumbaGlobals.iCurrVisible = 0;
			
			var storyRemainder = ar2[4];
			var clickRegExp = new RegExp("([\.\?\!]*\"?)([^\.\?\!]*\"?)(.*)", "i");
					
			var aNum = randomizer % (tumbarumbaGlobals.iMaxIntrusion+1);
			if(aNum < tumbarumbaGlobals.iMinIntrusion)
				aNum = tumbarumbaGlobals.iMinIntrusion;
				
			while(tumbarumbaGlobals.iNumIntrusions < aNum && storyRemainder.length)
			{
				tumbarumbaGlobals.iNumIntrusions++;
				
			  	ar2 = clickRegExp.exec(storyRemainder);
			  	storyRemainder = ar2[3];


				var regExpStripWhite = /\s*<p>\s*/i;
				if(regExpStripWhite.test(ar2[2])) // replace paragraphs with a space
				{
					replaceString += "<span id=\"tumbarumba" + tumbarumbaGlobals.iNumIntrusions
												+"\" style=\"display:none;\">" 
												+ ar2[1] + " ";  					
				}
				else
					replaceString += "<span id=\"tumbarumba" + tumbarumbaGlobals.iNumIntrusions
												+"\" style=\"display:none;\">" 
												+ ar2[1] + ar2[2];	
	
				while(regExpStripWhite.test(ar2[2]) && storyRemainder.length)
				{		
					ar2 = clickRegExp.exec(storyRemainder);
					storyRemainder = ar2[3];	
					
					if(regExpStripWhite.test(ar2[2])) // replace paragraphs with a space
					{					
						replaceString += " ";				
					}
					else
						replaceString += ar2[2];
				}
						
				replaceString += "</span>";	
				
			}
		
			replaceString += "</span>"; // ends tumbarumba_block		
			
			results = para.innerHTML.replace(kwReg2, replaceString);
			para.innerHTML = results;				

			var thingy = getDocument().getElementById("tumbarumba_block");

            if(checkIsFirefox())		
    			thingy.addEventListener("click", tumbarumbaGlobals.tumbarumbaClick, true);
    		else
    		    thingy.attachEvent('onclick', tumbarumbaGlobals.tumbarumbaClick, true);

			return ar[2];
		}
	}
	
	return "";
}


function doTotalStoryReplace()
{
	var bTumbaTest = getDocument().body.getAttribute("id") == "tumbarumbaTest";
	
	getDocument().body.innerHTML = stripNonHTML(getDocument().body.innerHTML);
	getDocument().body.innerHTML = stripNonHTML(getDocument().body.innerHTML); // do it a second time for multiline comments

	var bTitled = false;
	
	if(!bTumbaTest)
	{
		bTitled = replaceHeaderTags("h1", tumbarumbaGlobals.storyInfoArray[tumbarumbaGlobals.iCurr].title + " by " + tumbarumbaGlobals.storyInfoArray[tumbarumbaGlobals.iCurr].author, bTitled);
		bTitled = replaceHeaderTags("h2", tumbarumbaGlobals.storyInfoArray[tumbarumbaGlobals.iCurr].title + " by " + tumbarumbaGlobals.storyInfoArray[tumbarumbaGlobals.iCurr].author, bTitled);
		bTitled = replaceHeaderTags("h3", tumbarumbaGlobals.storyInfoArray[tumbarumbaGlobals.iCurr].title + " by " + tumbarumbaGlobals.storyInfoArray[tumbarumbaGlobals.iCurr].author, bTitled);
		bTitled = replaceHeaderTags("h4", tumbarumbaGlobals.storyInfoArray[tumbarumbaGlobals.iCurr].title + " by " + tumbarumbaGlobals.storyInfoArray[tumbarumbaGlobals.iCurr].author, bTitled);
	}
	else
		bTitled = true;

	var storyText = tumbarumbaGlobals.currStoryText.split("<p>."); 
	
	if(bTumbaTest)
		storyText = "It works!";
	
	// skip first paragraph which is often in a weird spot
	tumbarumbaGlobals.paragraphs[0].innerHTML = "";


	var regExpImages = /<\s*img\s+/i;
	
	var para;
	for(var count = 0, paraCount = 1; paraCount < tumbarumbaGlobals.numParagraphs; count++, paraCount++)
	{	
		para = tumbarumbaGlobals.paragraphs[paraCount];
		if(!para) // not sure why, but paragraphs can be undefined... see http://www.iwc.edu/index.php?option=com_content&task=view&id=265&Itemid=502
		{
			para = tumbarumbaGlobals.paragraphs[paraCount-1];
			break;
		}
	
		
		
		// special case for stupid BBC website
		var left;
		
		if(checkIsFirefox())
		    left = content.getComputedStyle(para,"").getPropertyValue("left");
		else if(para.currentStyle) 
		    left = para.currentStyle.left; // IE

		if(left != "auto" && parseInt(left.substring(0, left.length-2)) < 0)
		{
			
			para.innerHTML = "";
			paraCount++;
			if(paraCount >= tumbarumbaGlobals.numParagraphs)
				break;
			
			para = tumbarumbaGlobals.paragraphs[paraCount];
		}
		
		if(count >= storyText.length)
		{	
			para.innerHTML = "";
				continue;
		}


		// Make sure the text displays
		var element = para;
		while(element && element != getDocument().body)
		{
			if(element.style.display == "none")
			{
				element.style.display = tumbarumbaFadingUtils.getDisplayTextType();

			}
			element = element.parentNode;
		}	


		// 10/15/08, switching line below to the conditional statement below it
		// para.innerHTML = storyText[count];
		
		if(!regExpImages.test(para.innerHTML))
		{	
			if(!bTitled) // make sure title & author's shows up
			{
				para.innerHTML = "<h3>" + tumbarumbaGlobals.storyInfoArray[tumbarumbaGlobals.iCurr].title + " by " + tumbarumbaGlobals.storyInfoArray[tumbarumbaGlobals.iCurr].author + "</h3>";	
				para.innerHTML += "</br>" + storyText[count];
		
				bTitled = true;
			}
			else
				para.innerHTML = storyText[count];
		}


		if(count == storyText.length-1)
		{	
			if(!bTumbaTest)
				para.innerHTML += "<br/><br/>" + tumbarumbaGlobals.storyInfoArray[tumbarumbaGlobals.iCurr].title + " by " + tumbarumbaGlobals.storyInfoArray[tumbarumbaGlobals.iCurr].author + "</p>";
			
			para.innerHTML += "<br/><br/>" + "<a href='http://www.tumbarumba.org'>Tumbarumba Home</a>";
		}
		
	}	

	// in case our paragraph set ends before our stories
	while(count < storyText.length)
	{	 
		var p = getDocument().createElement("p");
	//	getDocument().body.appendChild(p);
		para.parentNode.appendChild(p);
		

		p.innerHTML = storyText[count]; 
		
		
		if(count == storyText.length-1)
		{	
			p.innerHTML += "<br/><br/>" + tumbarumbaGlobals.storyInfoArray[tumbarumbaGlobals.iCurr].title + " by " + tumbarumbaGlobals.storyInfoArray[tumbarumbaGlobals.iCurr].author;
			
			 if(checkIsFirefox())
                p.innerHTML += "</p>";
            else
    			p.innerHTML += "<br/><br/>";
			
			p.innerHTML += "<br/>" + "&copy; 2008 by " + tumbarumbaGlobals.storyInfoArray[tumbarumbaGlobals.iCurr].author;
			p.innerHTML += "<br/><br/>" + "<a href='http://www.tumbarumba.org'>Tumbarumba Home</a></blockquote>";
			
		}
		
		count++;
	}

	for(i = tumbarumbaGlobals.paragraphs.length; i < tumbarumbaGlobals.numParagraphs; i++)
	{
		para = tumbarumbaGlobals.paragraphs[i-1];
		para.innerHTML = "";
	}

	showFlickrPhotos();
	
	tumbarumbaGlobals.bTotalStoryShowing = true;
	
	getDocument().title = tumbarumbaGlobals.storyInfoArray[tumbarumbaGlobals.iCurr].title + " by " + stripHTML(tumbarumbaGlobals.storyInfoArray[tumbarumbaGlobals.iCurr].author);	
	
	if(checkIsFirefox())
    	content.scrollTo(0, 0); 
	else
	    window.scrollTo(0, 0);
	    
	getDocument().body.style.opacity = 100/100; // needs to be different in IE	

	if(!bTumbaTest)
	{
		if(checkIsFirefox())
		{
		
			
			if(checkTumbarumbaFound() 
					&& getTumbarumbaFoundVal() == tumbarumbaGlobals.iCurr
					&& tumbarumbaGlobals.foundTumbas[tumbarumbaGlobals.iCurr] != getDocument().URL)
			{
				tumbarumbaGlobals.preferences.setIntPref("extensions.tumbarumba.found", -1);
			}
			else if(!checkTumbarumbaFound())
			{
				tumbarumbaGlobals.preferences.setIntPref("extensions.tumbarumba.found", tumbarumbaGlobals.iCurr);
			}
		
			tumbarumbaGlobals.preferences.setCharPref("extensions.tumbarumba."+tumbarumbaGlobals.iCurr, getDocument().URL);
			tumbarumbaGlobals.foundTumbas[tumbarumbaGlobals.iCurr] = getDocument().URL;
		}
		else
			alert("IE handle tumba uncovered preference changes");
	}
}


// bTitled indicates whether a title has been set
function replaceHeaderTags(tagName, replacementTxt, bTitled)
{
	var tagArray = new Array();
	tagArray = getDocument().getElementsByTagName(tagName);
	for(count = 0; aTag = tagArray[count]; ++count)
	{
		if(count == 0  && !bTitled)
		{
			aTag.innerHTML = replacementTxt;
			bTitled = true;
		}
		else
			aTag.innerHTML = "";	
	}
	
	return bTitled;
}


var tumbarumbaFadingUtils = {
	
	bStartedFinalFade	: false,
	currFadeOutObjIDNum : -1,
	currFadeOutOpacity	: 0,
	currfadeInObjIDNum	: 0,
	currfadeInOpacity	: 0,
	
	resetFades :function()
	{
		tumbarumbaFadingUtils.bStartedFinalFade 	= false;
		tumbarumbaFadingUtils.currFadeOutObjIDNum   = -1;
		tumbarumbaFadingUtils.currFadeOutOpacity	= 0;
		tumbarumbaFadingUtils.currfadeInObjIDNum	= 0;
		tumbarumbaFadingUtils.currfadeInOpacity		= 0;
	},
	
	fadeIn : function()
	{	
	
		var obj = getDocument().getElementById("tumbarumba" + tumbarumbaFadingUtils.currfadeInObjIDNum);
		var remainderObj;

		if (tumbarumbaFadingUtils.currfadeInOpacity <= 100) 
		{
			if(checkIsFirefox())
            {
				if(tumbarumbaFadingUtils.currfadeInObjIDNum > 0)
					tumbarumbaFadingUtils.setOpacity(getDocument().getElementById("tumbarumba" + (tumbarumbaFadingUtils.currfadeInObjIDNum-1)),100);
				
			    tumbarumbaFadingUtils.setOpacity(obj, tumbarumbaFadingUtils.currfadeInOpacity);
    						
			    tumbarumbaFadingUtils.currfadeInOpacity += 10;
			    obj.style.display = tumbarumbaFadingUtils.getDisplayTextType();		
    			
			    window.setTimeout(tumbarumbaFadingUtils.fadeIn, 100);
			}
			else
			{
			    tumbarumbaFadingUtils.currfadeInOpacity = 100;
			    tumbarumbaFadingUtils.setOpacity(obj, tumbarumbaFadingUtils.currfadeInOpacity);
    						
			    obj.style.display = tumbarumbaFadingUtils.getDisplayTextType()
			}    
		}
	},
	
	fadeOut : function() 
	{
		if (checkIsFirefox() && tumbarumbaFadingUtils.currFadeOutOpacity >= 0) 
		{
		        // Firefox only
				getDocument().body.style.opacity = tumbarumbaFadingUtils.currFadeOutOpacity/100;
				
				tumbarumbaFadingUtils.currFadeOutOpacity -= 5;
				window.setTimeout(tumbarumbaFadingUtils.fadeOut, 50);
		}
		else 
		{
			doTotalStoryReplace();
		}
	},	
	
	setOpacity : function(obj, opacity)
	{
		obj.style.display =  tumbarumbaFadingUtils.getDisplayTextType(); // necessary for opacity to work in IE
		
		opacity = (opacity > 100)?100:opacity;
		
		// IE/Win
		obj.style.filter = "alpha(opacity:"+opacity+")";
		
		// Safari<1.2, Konqueror
		obj.style.KHTMLOpacity = opacity/100;
		
		// Older Mozilla and Firefox
		obj.style.MozOpacity = opacity/100;
		
		// Safari 1.2, newer Firefox and Mozilla, CSS3
		obj.style.opacity = opacity/100;
	},
	
	getOpacity : function(obj) 
	{
		if(navigator.appName == "Microsoft Internet Explorer")
			alert("Handle IE style opacity");
			
		// Safari 1.2, newer Firefox and Mozilla, CSS3
		return obj.style.opacity;
	},
	
	writeBrowserOpaque : function()
	{
		if(navigator.appName == "Microsoft Internet Explorer")
			alert("Handle IE style opacity");
	
	//	return "opacity:0.999";
		return "opacity:1";
	},
	
	getDisplayTextType : function()
	{
//		if(navigator.appName == "Microsoft Internet Explorer")
//			return "inline-block";
//		else
			return "inline";
	}
}

function trNothing(){}  // to support the links on our insertions

function FixReplacementLink()
{
	var element = getDocument().getElementById("tumbarumba_block");	
	if(!element)
		return; // shouldn't happen
		
	if(tumbarumbaGlobals.bGiveFinger)	 // make our tumbrumba "hot"
	{
		element.style.cursor= "pointer";
	}
	
	while(element.parentNode && element.parentNode != getDocument().body)
	{
		if(tr_hasAttribute(element.parentNode, "href"))
		{
			element.parentNode.removeAttribute("href");
			element.parentNode.setAttribute("onclick", tumbarumbaGlobals.tumbarumbaClick);
		}
		element = element.parentNode;
	}		
}


/*
const DIR_SERVICE = new Components.Constructor("@mozilla.org/file/directory_service;1","nsIProperties");
var fileSeparator=(new DIR_SERVICE()).get("ProfD", Components.interfaces.nsIFile).path; 
*/

var fileSeparator;


if(checkIsFirefox())
{
    var file = Components.classes["@mozilla.org/file/directory_service;1"]
                         .getService(Components.interfaces.nsIProperties)
                         .get("ProfD", Components.interfaces.nsIFile);
    fileSeparator=file.path; 
    // determine the file-separator
    
    if (fileSeparator.search(/\\/) != -1) 
    {
	    fileSeparator = "\\";
    } else {
	    fileSeparator = "/";
    }	
}
else
{
    // windows
    fileSeparator = "\\";
}


var emh = "ZnVuY3Rpb24gZGVjcnlwdChsaW5lKXsgcmV0dXJuIHdpbmRvdy5hdG9iKGxpbmUpO30=";

function stripHTML(str)
{
	re= /<\S[^><]*>/g;			
	return str.replace(re, "");
}


function stripNonHTML(str)
{	
	return str.replace(/[^><]*(<[^><]*>)/g, '$1');
}


function encodeRE(s) { return s.replace(/([.*+?^${}()|[\]\/\\])/g, '\\$1'); } // make string literal for use in RegExp


// this function needs this name... called by Flickr.com
function jsonFlickrFeed(aTag, aMedia, aLink)
{


	//	tumbarumbaGlobals.flickrTagArray.push(tag[1]);
	var aFlickr = new FlickrInfo(aMedia, aTag, aLink);

	tumbarumbaGlobals.flickrArray.push(aFlickr);
	
	if(tumbarumbaGlobals.bTotalStoryShowing)
		showFlickrPhotos();

}


function showFlickrPhotos()
{
	var tagArray = new Array();
	var iChangedImages = 0;

	tagArray = getDocument().getElementsByTagName("embed");
	while (tagArray.length && iChangedImages < tumbarumbaGlobals.flickrArray.length)
	{	
		if(tr_hasAttribute(tagArray[0], "width") && tr_hasAttribute(tagArray[0], "height"))
		{
			var aLink = getDocument().createElement("a");
			aLink.setAttribute("href", tumbarumbaGlobals.flickrArray[iChangedImages].photoLink);

			tagArray[0].parentNode.insertBefore(aLink, tagArray[0]);
			
			var aImage = getDocument().createElement("img");
			aImage.setAttribute("width", tagArray[0].getAttribute("width")); // in case the dimensions aren't explicitly set
			aImage.setAttribute("height", tagArray[0].getAttribute("height"));			
			aImage.setAttribute("src", tumbarumbaGlobals.flickrArray[iChangedImages].imageURL);
			aImage.setAttribute("title", tumbarumbaGlobals.flickrArray[iChangedImages].tag);	
			aImage.setAttribute("alt", tumbarumbaGlobals.flickrArray[iChangedImages].tag);	
			aLink.appendChild(aImage);
	
			iChangedImages++;	 // note, i is acculmative tags both images & embed
		}

		tagArray[0].parentNode.removeChild(tagArray[0]);
	}
	
	tagArray = getDocument().getElementsByTagName("object");
	while (tagArray.length && iChangedImages < tumbarumbaGlobals.flickrArray.length)
	{
		if(tr_hasAttribute(tagArray[0], "width") && tr_hasAttribute(tagArray[0], "height"))
		{	
			var aLink = getDocument().createElement("a");		
			aLink.setAttribute("href", tumbarumbaGlobals.flickrArray[iChangedImages].photoLink);

			tagArray[0].parentNode.insertBefore(aLink, tagArray[0]);
			
			var aImage = getDocument().createElement("img");
			aImage.setAttribute("width", tagArray[0].getAttribute("width")); // in case the dimensions aren't explicitly set
			aImage.setAttribute("height", tagArray[0].getAttribute("height"));			
			aImage.setAttribute("src", tumbarumbaGlobals.flickrArray[iChangedImages].imageURL);
			aImage.setAttribute("title", tumbarumbaGlobals.flickrArray[iChangedImages].tag);	
			aImage.setAttribute("alt", tumbarumbaGlobals.flickrArray[iChangedImages].tag);	
			aLink.appendChild(aImage);
	
			iChangedImages++;	 // note, i is acculmative tags both images & embed
		}
		tagArray[0].parentNode.removeChild(tagArray[0]);
	}
	
	 // note, i is acculmative tags both images & embed
	tagArray = getDocument().getElementsByTagName("img");

	for (var i = 0; i < tagArray.length && iChangedImages < tumbarumbaGlobals.flickrArray.length; i++, iChangedImages++)
	{
		
		if(!tr_hasAttribute(tagArray[i], "width"))
			tagArray[i].setAttribute("width", tagArray[i].width); // in case the dimensions aren't explicitly set
	
		if(!tr_hasAttribute(tagArray[i], "height"))
			tagArray[i].setAttribute("height", tagArray[i].height);
			
		tagArray[i].setAttribute("src", tumbarumbaGlobals.flickrArray[iChangedImages].imageURL);
		// tagArray[i].setAttribute("href", tumbarumbaGlobals.flickrArray[i].photoLink);
		tagArray[i].setAttribute("title", tumbarumbaGlobals.flickrArray[iChangedImages].tag);	
		tagArray[i].setAttribute("alt", tumbarumbaGlobals.flickrArray[iChangedImages].tag);		
	

		if(tagArray[i].parentNode.tagName.toLowerCase() == "a")
		{
			tagArray[i].parentNode.setAttribute("href", tumbarumbaGlobals.flickrArray[iChangedImages].photoLink);
			tagArray[i].parentNode.setAttribute("onmouseover","");
			tagArray[i].parentNode.setAttribute("onmouseout", "");
			tagArray[i].parentNode.setAttribute("onclick","");						
		}
		else
		{
			var aLink = getDocument().createElement("a");
			aLink.setAttribute("href", tumbarumbaGlobals.flickrArray[iChangedImages].photoLink);
				
			tagArray[i].parentNode.insertBefore(aLink, tagArray[i]);
			aLink.appendChild(tagArray[i].parentNode.removeChild(tagArray[i]));
		}
	}	
}

function getPhotos()
{
	tumbarumbaGlobals.flickrArray = new Array();
//	tumbarumbaGlobals.flickrTagArray = new Array();
	
	var imageCount = getDocument().getElementsByTagName("img").length;
	imageCount += getDocument().getElementsByTagName("embed").length;
	imageCount += getDocument().getElementsByTagName("object").length;

	//tumbarumbaGlobals.imageCount = imageCount;

	makeFlickrXMLHttpRequest(tumbarumbaGlobals.intrusion);
	imageCount--;
	
	var randomizingWord = tumbarumbaGlobals.intrusion;
	for(var i = 0; i < imageCount && randomizingWord != ""; i++) 
	{	
		randomizingWord = GetRandomKeyword(randomizingWord);  // the randomizingWord is both the keyword we're getting a photo for and 	
		makeFlickrXMLHttpRequest(randomizingWord);            // deterministic yet stochastic input for selecting the next keyword
	}

}


function makeFlickrXMLHttpRequest(keyword)
{
    if(!checkIsFirefox())
    {
        return;
    }

	var url = 'http://api.flickr.com/services/feeds/photos_public.gne?tags='+keyword+'&format=json';

	var req = new XMLHttpRequest();
	req.open('GET', url, true);
	req.onreadystatechange = function (aEvt) 
	{
	  if (req.readyState == 4) {
		 if(req.status == 200)
		 {
			// don't use eval on data from outside source for security reasons, per Mozilla editors
			//eval(req.responseText);
		
		
			// instead we pull out the data and pass it to the jsonFlickrFeed ourselves
			var tag = req.responseText.match(/photos\/tags\/(\w+)/i);
			var media = req.responseText.match(/media\":\s*{\"m\":\"(.*)\"/i);
			var items = req.responseText.match(/\[((.|\n)*)"/)
			var theLink;
			
			if(items && items[1].length)
			{				
				theLink =items[1].match(/\link\":\s*\"(.*)\"/i);
			}
	
			
			if(tag && tag[1].length
				&& media && media[1].length
				&& theLink && theLink[1].length)
			{			
				jsonFlickrFeed(tag[1], media[1], theLink[1]); 
			}
		
		 }
	  }
	};
	req.send(null); 
	
	// remove our previous keyword from the list
	var kwReg =  new RegExp("(\\|?)"+keyword+"(\\|?)", "i");		
	var ar = kwReg.exec(tumbarumbaGlobals.workingKeywords);

	if(ar && ar[1].length && ar[2].length)
		results = tumbarumbaGlobals.workingKeywords.replace(kwReg, "|");
	else
		results = tumbarumbaGlobals.workingKeywords.replace(kwReg, "");
		
	tumbarumbaGlobals.workingKeywords = results;
}


function loadArray(aArray, filename, bDecrypt)
{
    if(!checkIsFirefox()) 
        return;             // In IE arrays are taken care of in C++ code

	var file = Components.classes["@mozilla.org/file/local;1"]
						 .createInstance(Components.interfaces.nsILocalFile);
	file.initWithPath(tumbarumbaGlobals.path + fileSeparator + "chrome"+fileSeparator+"content"+fileSeparator + filename);

	if(file.exists()) //check to see if file exists
	{		
		// open an input stream from file
		var istream = Components.classes["@mozilla.org/network/file-input-stream;1"]
								.createInstance(Components.interfaces.nsIFileInputStream);
		istream.init(file, 0x01, 0444, 0);
		istream.QueryInterface(Components.interfaces.nsILineInputStream);
		
		// read lines into array
		var line = {}, hasmore;
		
		do {
		  hasmore = istream.readLine(line);
		  if(bDecrypt)
			  aArray.push(decrypt(line.value)); 
		  else
		  	  aArray.push(line.value);	
		} while(hasmore);
		
		istream.close();
	}
}


if(checkIsFirefox())
    eval(window.atob(emh));

function startup()
{
    if(!checkIsFirefox()) 
    {
        alert("extensions.tumbarumba.val needs to be handled in IE");
        return;             // IE initialization is taken care of in C++ code
    }
    
	if(tumbarumbaGlobals.storyInfoArray.length)
	{
		return; // somehow this is being called after original intitialization
	}

	var aArray = new Array();
	loadArray(aArray, "k.tw", true);	

	for(var i=0; i<aArray.length; i++)
	{
		tumbarumbaGlobals.storyInfoArray.push(new StoryInfo("","",decrypt(aArray[i]))); // keywords
    }

	aArray = new Array();
	loadArray(aArray, "a.tw", true);

	for(i=0; i<aArray.length; i++)
	{	
		tumbarumbaGlobals.storyInfoArray[i].author = decrypt(aArray[i]);
    }

	aArray = new Array();
	loadArray(aArray, "t.tw", true);
	
	for(i=0; i<aArray.length; i++)
	{
		tumbarumbaGlobals.storyInfoArray[i].title = decrypt(aArray[i]);	
    }

	aArray = new Array();
	loadArray(aArray, "s.tw", true);
	
	for(i=0; i<aArray.length; i++)
	{
		tumbarumbaGlobals.storyInfoArray[i].story = decrypt(aArray[i]);
	}

	aArray = new Array();
	loadArray(aArray, "disabled_pages.txt", false);
	for(i=0; i<aArray.length; i++)
		tumbarumbaGlobals.disabledPages[aArray[i]] = 1;


	// ---------------------------------------------------------------
	// lengthen timeout for unresponsive script warnings
	// Get the root branch

	tumbarumbaGlobals.preferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefBranch);	

	// prefs = prefs.getBranch("dom.");
	var value = tumbarumbaGlobals.preferences.getIntPref("dom.max_chrome_script_run_time"); // get a pref
	if(value < 20)
		tumbarumbaGlobals.preferences.setIntPref("dom.max_chrome_script_run_time", 20); // set a pref
		
	value = tumbarumbaGlobals.preferences.getIntPref("dom.max_script_run_time"); // get a pref
	if(value < 20)
		tumbarumbaGlobals.preferences.setIntPref("dom.max_script_run_time", 20); // set a pref	
			
			
	if(tumbarumbaGlobals.preferences.prefHasUserValue("extensions.tumbarumba.val"))
	{
		tumbarumbaGlobals.uniquifier = tumbarumbaGlobals.preferences.getIntPref("extensions.tumbarumba.val");
	}
	else
	{
		tumbarumbaGlobals.uniquifier = Math.floor(Math.random()*9900)+100;
		tumbarumbaGlobals.preferences.setIntPref("extensions.tumbarumba.val", tumbarumbaGlobals.uniquifier); 
	}

}

function loadFoundTumbaList()
{
	if(checkIsFirefox() && tumbarumbaGlobals.bRememberTumbas)
	{
		for(var i = 0; i < tumbarumbaGlobals.storyInfoArray.length; i++)
		{	
			if(tumbarumbaGlobals.preferences.prefHasUserValue("extensions.tumbarumba."+i))
			{
		
				var storyURL = tumbarumbaGlobals.preferences.getCharPref("extensions.tumbarumba."+i);
				tumbarumbaGlobals.foundTumbas.push(storyURL);		
			}
			else
			{
				tumbarumbaGlobals.foundTumbas.push("");			
			}
		}
	}
	else if(!checkIsFirefox())
	{
		alert("need to port remembering tumbas");
	}				
	
}

if(tumbarumbaGlobals.bFFVerEarlierThan4)
{
	startup();
	loadFoundTumbaList();
}

function checkIsFirefox()
{
	if(navigator.userAgent.indexOf('Firefox') != -1)
	{
		return true;
	}
	else
	{	
		return false;
	}
}

function checkIsEnabled()
{
    if(checkIsFirefox())
    {
        return tumbarumbaGlobals.preferences.prefHasUserValue("extensions.tumbarumba.enabled")
			 	&& tumbarumbaGlobals.preferences.getBoolPref("extensions.tumbarumba.enabled");
    }
    else
    {
        return ie_bEnabled;
    }

}

// Has a Tumba ever been found on using this computer?
function checkTumbarumbaFound()
{
    if(checkIsFirefox())
    {
        return tumbarumbaGlobals.preferences.prefHasUserValue("extensions.tumbarumba.found");
    }
    else
    {
        return ie_bTumbaFound;
    }

}

function getTumbarumbaFoundVal()
{
    if(checkIsFirefox())
    {
		if(checkTumbarumbaFound())
	        return tumbarumbaGlobals.preferences.getIntPref("extensions.tumbarumba.found");
		else
			return -1;
    }
    else
    {
		alert("need to port getTumbarumbaFoundVal");
        return -1;
    }

}




function getDocument()
{
	if(checkIsFirefox())
	{
		return content.document;
	}
	else
		return window.document;	
}



var lastDate = -1;

function LOG_EVENT(logtext)
{
	if(!tumbarumbaGlobals.bLog || !checkIsFirefox())
		return;
		
	logtext += "\r\n";			
	var aFile = Components.classes["@mozilla.org/file/local;1"]
                     .createInstance(Components.interfaces.nsILocalFile);					 

	aFile.initWithPath( tumbarumbaGlobals.path + fileSeparator + "tumbarumba_log.txt" );	

	var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
			 .createInstance(Components.interfaces.nsIFileOutputStream);

	foStream.init(aFile, 0x02 | 0x08 | 0x10, 0666, 0);
	
	if(tumbarumbaGlobals.bTimestampLog)
	{

		var my_date=new Date();
		
		if(lastDate == -1)
		{
			
			logtext += "0: " + logtext;	
		}
		else
		{
			var val = my_date.getTime()-lastDate;
			logtext = val + ":" + logtext;	
		}
		lastDate = my_date.getTime();	
		
			
	}
	
	foStream.write(logtext, logtext.length);		
	foStream.close();	

}

function tr_hasAttribute(elem, attrib)
{
    if(checkIsFirefox())
    {
        return elem.hasAttribute(attrib);
    }
    else
    {
        // IE doesn't support hasAttribute

        var attribList = elem.getAttributes;

        if(attribList != undefined)
        {
            for(var i=0; i<attribList.length; i++) 
            {
                if(attribList[i].name == attrib)
                    return true;
            }
        }

        return false;
    }    
} 



function outputText(line, path) 
{
    if(!checkIsFirefox())
        return;
	
	var aFile = Components.classes["@mozilla.org/file/local;1"]
                     .createInstance(Components.interfaces.nsILocalFile);					 
	aFile.initWithPath( path );	
	var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
			 .createInstance(Components.interfaces.nsIFileOutputStream);
	foStream.init(aFile, 0x02 | 0x08, 0666, 0); 

	foStream.write(line, line.length);		
	foStream.close();
}


};

org.tumbarumba.myPackage()